<h1 align="center"><img height="150" src="https://raw.githubusercontent.com/namitoyokota/ngx-code-snippet/master/src/assets/logo.png" /><br> Code Snippet</h1>

<p align="center">
    <a href="https://github.com/namitoyokota/ngx-code-snippet/blob/master/LICENSE">
        <img alt="GitHub License" src="https://img.shields.io/github/license/namitoyokota/ngx-code-snippet" />
    </a>
    <a href="https://www.npmjs.com/package/ngx-code-snippet">
        <img alt="NPM Version" src="https://img.shields.io/npm/v/ngx-code-snippet.svg" />
    </a>
    <a href="https://www.npmjs.com/package/ngx-code-snippet">
        <img alt="NPM Downloads" src="https://img.shields.io/npm/dt/ngx-code-snippet" />
    </a>
</p>

<p align="center">
    <b>Code Snippet</b> is an Angular component to display syntax highlighting to code snippets.
</p>

## Demo

![Demo Gif](https://raw.githubusercontent.com/namitoyokota/ngx-code-snippet/master/src/assets/demo.gif)

View the [live demo](https://code-snippet.namitoyokota.com/) or [CodeSandbox](https://codesandbox.io/p/devbox/ngx-code-snippet-demo-mf875r)!

## Installation

Install using a package manager:

```shell
npm i ngx-code-snippet
```

or

```shell
yarn add ngx-code-snippet
```

## Usage

First, import the module.

```typescript
import { CodeSnippetModule } from 'ngx-code-snippet';

@NgModule({
    imports: [CodeSnippetModule],
})
export class AppModule {}
```

Next, set up a config property. You can read all annotation types on Rough Notation's official documentation.

```typescript
readonly underline = {
    type: 'underline',
    color: '#F38181',
} as RoughAnnotationConfig;
```

Lastly, add component in the HTML.

```html
<code-snippet [config]="underline">This sentence will be underlined.</code-snippet>
```

## Directives

Optionally, override the reset flag to avoid re-animations.

```html
<code-snippet [reset]="false"></code-snippet>
```

Delay, set to 1000 milliseconds (1 second) by default, can also be overridden.

```html
<code-snippet [delay]="5000"></code-snippet>
```

## License

[MIT](https://github.com/namitoyokota/ngx-code-snippet/blob/master/LICENSE) &copy; [Namito Yokota](https://www.namitoyokota.com)
